default:
  tags:
  - docker
  image: osrf/ros:noetic-desktop-full

stages:
  - build 
  - analysis

before_script:
    - apt update
    - apt upgrade -y
    - sudo apt install python3-rosdep python3-catkin-tools build-essential cmake git libpoco-dev libeigen3-dev -y

# builds  
build:noetic:
  stage: build
  script:
    - ls -la
    - rm -rf panda_qp_ws/*
    - mkdir .init_content
    - mv * .init_content
    - mkdir -p panda_qp_ws/src/
    - cp -rf .init_content/* panda_qp_ws/src/
    - cd panda_qp_ws/src
    - git submodule sync
    - git submodule update --init --recursive
    - rosdep install --from-paths ../src --ignore-src -r -y
    - cd ..
    - catkin config --init  
    - catkin build
    - ls src/
  artifacts:
    paths:
      - panda_qp_ws/src
      - panda_qp_ws/build
      - panda_qp_ws/devel  

analysis:
  stage: analysis
  dependencies:
    - build:noetic
  artifacts:
    paths:
      - panda_qp_ws/src
      - panda_qp_ws/build
      - panda_qp_ws/devel  

  script:
    - ls -la
    - rosdep install --from-paths panda_qp_ws/src --ignore-src -r -y
    - source panda_qp_ws/devel/setup.bash
    - timeout 30s roslaunch panda_qp_control velocity_control.launch sim:=true|| echo exit code $?
